    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * ---------------------
    028 * FontDisplayField.java
    029 * ---------------------
    030 * (C) Copyright 2000-2008, by Object Refinery Limited.
    031 *
    032 * Original Author:  David Gilbert (for Object Refinery Limited);
    033 * Contributor(s):   Arnaud Lelievre;
    034 *
    035 * $Id: FontDisplayField.java,v 1.6 2008/12/18 09:57:32 mungady Exp $
    036 *
    037 * Changes (from 26-Oct-2001)
    038 * ----------------------------------
    039 * 26-Oct-2001 : Changed package to com.jrefinery.ui.*;
    040 * 14-Oct-2002 : Fixed errors reported by Checkstyle (DG);
    041 * 08-Sep-2003 : Added internationalization via use of properties
    042 *               resourceBundle (RFE 690236) (AL);
    043 * 18-Dec-2008 : Use ResourceBundleWrapper - see JFreeChart patch 1607918 by
    044 *               Jess Thrysoee (DG);
    045 *
    046 */
    047
    048package org.jfree.ui;
    049
    050import java.awt.Font;
    051import java.util.ResourceBundle;
    052
    053import javax.swing.JTextField;
    054
    055import org.jfree.util.ResourceBundleWrapper;
    056
    057/**
    058 * A field for displaying a font selection.  The display field itself is
    059 * read-only, to the developer must provide another mechanism to allow the
    060 * user to change the font.
    061 *
    062 * @author David Gilbert
    063 */
    064public class FontDisplayField extends JTextField {
    065
    066    /** The current font. */
    067    private Font displayFont;
    068
    069    /** The resourceBundle for the localization. */
    070    protected static final ResourceBundle localizationResources =
    071            ResourceBundleWrapper.getBundle("org.jfree.ui.LocalizationBundle");
    072
    073    /**
    074     * Standard constructor - builds a FontDescriptionField initialised with
    075     * the specified font.
    076     *
    077     * @param font  the font.
    078     */
    079    public FontDisplayField(final Font font) {
    080        super("");
    081        setDisplayFont(font);
    082        setEnabled(false);
    083    }
    084
    085    /**
    086     * Returns the current font.
    087     *
    088     * @return the font.
    089     */
    090    public Font getDisplayFont() {
    091        return this.displayFont;
    092    }
    093
    094    /**
    095     * Sets the font.
    096     *
    097     * @param font  the font.
    098     */
    099    public void setDisplayFont(final Font font) {
    100        this.displayFont = font;
    101        setText(fontToString(this.displayFont));
    102    }
    103
    104    /**
    105     * Returns a string representation of the specified font.
    106     *
    107     * @param font  the font.
    108     *
    109     * @return a string describing the font.
    110     */
    111    private String fontToString(final Font font) {
    112        if (font != null) {
    113            return font.getFontName() + ", " + font.getSize();
    114        }
    115        else {
    116            return localizationResources.getString("No_Font_Selected");
    117        }
    118    }
    119
    120}